"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class gps_lcm(object):
    __slots__ = ["time", "latitude", "ns", "longitude", "sw", "altitude", "hour", "minute", "second", "lat_deg", "lat_cent", "lat_sec", "long_deg", "long_cent", "long_sec", "utm_x", "utm_y", "utm_zonenumber", "utm_zoneletter", "gpgga"]

    def __init__(self):
        self.time = 0
        self.latitude = 0.0
        self.ns = ""
        self.longitude = 0.0
        self.sw = ""
        self.altitude = 0
        self.hour = 0
        self.minute = 0
        self.second = 0
        self.lat_deg = 0
        self.lat_cent = 0
        self.lat_sec = 0
        self.long_deg = 0
        self.long_cent = 0
        self.long_sec = 0
        self.utm_x = 0.0
        self.utm_y = 0.0
        self.utm_zonenumber = 0
        self.utm_zoneletter = ""
        self.gpgga = ""

    def encode(self):
        buf = BytesIO()
        buf.write(gps_lcm._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">id", self.time, self.latitude))
        __ns_encoded = self.ns.encode('utf-8')
        buf.write(struct.pack('>I', len(__ns_encoded)+1))
        buf.write(__ns_encoded)
        buf.write(b"\0")
        buf.write(struct.pack(">d", self.longitude))
        __sw_encoded = self.sw.encode('utf-8')
        buf.write(struct.pack('>I', len(__sw_encoded)+1))
        buf.write(__sw_encoded)
        buf.write(b"\0")
        buf.write(struct.pack(">iiiiiiiiiiddi", self.altitude, self.hour, self.minute, self.second, self.lat_deg, self.lat_cent, self.lat_sec, self.long_deg, self.long_cent, self.long_sec, self.utm_x, self.utm_y, self.utm_zonenumber))
        __utm_zoneletter_encoded = self.utm_zoneletter.encode('utf-8')
        buf.write(struct.pack('>I', len(__utm_zoneletter_encoded)+1))
        buf.write(__utm_zoneletter_encoded)
        buf.write(b"\0")
        __gpgga_encoded = self.gpgga.encode('utf-8')
        buf.write(struct.pack('>I', len(__gpgga_encoded)+1))
        buf.write(__gpgga_encoded)
        buf.write(b"\0")

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != gps_lcm._get_packed_fingerprint():
            raise ValueError("Decode error")
        return gps_lcm._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = gps_lcm()
        self.time, self.latitude = struct.unpack(">id", buf.read(12))
        __ns_len = struct.unpack('>I', buf.read(4))[0]
        self.ns = buf.read(__ns_len)[:-1].decode('utf-8', 'replace')
        self.longitude = struct.unpack(">d", buf.read(8))[0]
        __sw_len = struct.unpack('>I', buf.read(4))[0]
        self.sw = buf.read(__sw_len)[:-1].decode('utf-8', 'replace')
        self.altitude, self.hour, self.minute, self.second, self.lat_deg, self.lat_cent, self.lat_sec, self.long_deg, self.long_cent, self.long_sec, self.utm_x, self.utm_y, self.utm_zonenumber = struct.unpack(">iiiiiiiiiiddi", buf.read(60))
        __utm_zoneletter_len = struct.unpack('>I', buf.read(4))[0]
        self.utm_zoneletter = buf.read(__utm_zoneletter_len)[:-1].decode('utf-8', 'replace')
        __gpgga_len = struct.unpack('>I', buf.read(4))[0]
        self.gpgga = buf.read(__gpgga_len)[:-1].decode('utf-8', 'replace')
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if gps_lcm in parents: return 0
        tmphash = (0x202a0dcb8185d9c7) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if gps_lcm._packed_fingerprint is None:
            gps_lcm._packed_fingerprint = struct.pack(">Q", gps_lcm._get_hash_recursive([]))
        return gps_lcm._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

